<?
/*
Copyright by Gary Fung, isoHunt.com
Permission granted for reuse, under the BSD license: http://www.opensource.org/licenses/bsd-license.php
*/

require_once 'BDecode.php';
require_once 'BEncode.php';
$array = BDecode($torrent);   // $torrent is raw contents of .torrent file
if (!is_array($array['info'])) return FALSE;

$ver = 'BTHub v0.4';
$info = $array['info'];
$hash = sha1(BEncode($info));

if ((string) $array['announce-orig'] != '') $announce = $array['announce-orig'];
else $announce = trim(str_replace('\\', '/', $array['announce']), "/ \t\n\r\0\x0B");

$announce_o = 'invalid';
if (substr($announce, 0, 7) == 'http://' && stristr($announce, ' ') === FALSE &&
    preg_match('/^http:\/\/([\w-\.]+)(:(\d+))?\/(([\w-\.]+\/)*)(.*)$/i', $announce, $match) &&
    substr($match[1], -9) != 'bthub.com' &&
    (preg_match('/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/', $match[1]) || !str_is_int(substr($match[1], -1))) &&
    preg_match('/\.[a-z]{2,3}$/i', $match[1])) {
  $ann_domain = $match[1];
  if ((string) $match[3] != '') $ann_port = $match[3];
  else $ann_port = 80;
  $ann_path = $match[4];
  $ann_file = $match[6];
  if (stristr($ann_file, 'announce') === FALSE) {
    $ann_path .= $ann_file.'/';
    $ann_file = 'announce';
  }
  $scrape = mysql_escape_string('http://'.$ann_domain.':'.$ann_port.'/'.$ann_path.str_replace('announce', 'scrape', $ann_file));
  if (strlen($scrape) <= 255) $announce_o = 'http://'.$ann_domain.':'.$ann_port.'/'.$ann_path.$ann_file;
}

if ($announce_o != 'invalid') {
  if (!is_array($array['modified-by']) || !in_array($ver, $array['modified-by'])) $array['modified-by'][] = $ver;
  if (!isset($array['announce-list']) || count($array['announce-list'][0]) == 1) {
    unset($array['announce-list']);
    $array['announce-list'][][] = $announce;
    $array['announce-list'][][] = 'http://'.$hash.'.bthub.com:'.$ann_port.'/'.$ann_path.$ann_file;
  }
  else {
    $tier1 = $array['announce-list'][0];
    foreach ($tier1 as $left => $right) {
      preg_match('/^http:\/\/([\w-\.]+)(:(\d+))?\/(([\w-\.]+\/)*)(.*)$/i', $right, $match);
      if ((string) $match[3] == '') $match[3] = 80;
      $tier1[$left] = 'http://'.$hash.'.bthub.com:'.$match[3].'/'.$match[4].$match[6];
    }
    unset($array['announce-list']);
    $array['announce-list'][][] = $announce;
    if (is_array($tier1)) $array['announce-list'][] = $tier1;
  }
  $standard = 0;
  if ((string) $ann_path == '') {
    if (substr($announce_o, -14) == ':6969/announce') $standard = 1;
    elseif (substr($announce_o, -24) == ':80/tracker.php/announce') $standard = 2;
    elseif (substr($announce_o, -16) == ':80/announce.php') $standard = 3;
  }
  $array['announce-list'][][] = 'http://'.$hash.'.bthub.com:2710/announce';   // isoHunt's default port
  $array['announce-list'][][] = 'http://'.$hash.'.bthub.com:6969/announce';   // default BitTorrent port
  $array['announce-list'][][] = 'http://redir.bthub.com/redir.php?hash='.$hash; // future URL remapping
}

$torrent = BEncode($array);
?>
